//--------------------------------------------------------------------------------
//Titel:		TWI-Master
//Beschreibung:	2 Taster schalten 2 LEDs an anderem Controller
//Prozessor:	Atmega8
//Sprache:		C
//Autor:		Kevin Baumann, David Schneider, Philipp Horsch
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//Einbinden der bentigten Bibliotheken
//--------------------------------------------------------------------------------
#include <avr/io.h>
#include "i2cmaster.h"

//--------------------------------------------------------------------------------
//Definieren der Variablen
//--------------------------------------------------------------------------------
#define SLAVE_ADRESSE 0x50
uint8_t Taster; 

//--------------------------------------------------------------------------------
//Hauptprogramm
//--------------------------------------------------------------------------------
int main(void)
{
	DDRB  = 0b00000000;		//Deklariere PortB als Eingang
	PORTB = 0b00000011;		//Pull-Up an PortB.0 und B.1 setzen
	PORTC = 0b00110000;		//Pull-Up an PortC.4 und C.5 setzen (SCL)
	Taster = 0x00;
	
	i2c_init();				//init I2C interface
	
	while (1)				//Endlosschleife
	{
		if (bit_is_clear (PINB, 0))	//Wenn Taster 1 bettigt ist
		{
			Taster |= (1<<0);		//setze Bit 0 von Byte "Taster"
		}
		else						//sonst
		{
			Taster &= ~(1<<0);;		//lsche Bit 0 von Byte "Taster" 
		}
		
		if (bit_is_clear (PINB, 1)) //Wenn Taster 2 bettigt ist
		{
			Taster |= (1<<1);		//setze Bit 1 von Byte "Taster"
		}
		else						//sonst
		{
			Taster &= ~(1<<1);;		//lsche Bit 1 von Byte "Taster"
		}
		 
		if(!(i2c_start(SLAVE_ADRESSE+I2C_WRITE))) //Slave bereit zum schreiben?
		{
			i2c_write(0x00);						// Buffer Startadresse setzen
			i2c_write(Taster);						// Ein Bytes schreiben...
			i2c_stop();								// Zugriff beenden
		}
	}
}