//--------------------------------------------------------------------------------------
//Titel:		TWI-Slave
//Beschreibung:	2 Taster schalten 2 LEDs an anderem Controller
//Prozessor:	Atmega8
//Sprache:		C
//Autor:		Kevin Baumann, David Schneider, Philipp Horsch
//--------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------
//Einbinden der bentigten Bibliotheken
//--------------------------------------------------------------------------------------
#include <util/twi.h> 	    
#include <stdint.h> 	    
#include "twislave.h"

//--------------------------------------------------------------------------------------
//Definieren der Variablen
//--------------------------------------------------------------------------------------
#define SLAVE_ADRESSE 0x50 //Die Slave-Adresse

//--------------------------------------------------------------------------------------
//Hauptprogramm
//--------------------------------------------------------------------------------------
int main (void)																						
{
	DDRB  = 0b00000011;		//Deklariere PortB.0 und B.1 als Ausganung
							//und alle anderen Pins als Eingang
	PORTB = 0b00001100;		//Pull-Up an PINB.2 und B.3 setzen	
	
	//TWI als Slave mit Adresse slaveadr starten
	init_twi_slave(SLAVE_ADRESSE);	//init I2C interface
	
	while(1)						//Endlosschleife
	{
		switch (i2cdata[0])			//Lese Wert in empfangenen Byte "i2cdata[0]"
		{
			case 0: PORTB &= ~(1<<0);			//Wenn Wert = 0, dann schalte Lampe
					PORTB &= ~(1<<1); break;	//1 und 2 aus
			case 1: PORTB |= (1<<0); break;		//Wenn Wert = 0, dann schalte Lampe 1 ein
			case 2: PORTB |= (1<<1); break;		//Wenn Wert = 0, dann schalte Lampe 2 ein			
			case 3: PORTB |= (1<<0);			//Wenn Wert = 0, dann schalte Lampe
					PORTB |= (1<<1); break;		//1 und 2 aus
		}
	} 
} //end.main
